--- 1/res/res_rtp_asterisk.c	2020-03-24 17:53:12.433056136 +0100
+++ 2/res/res_rtp_asterisk.c	2020-04-12 20:29:52.750178732 +0200
@@ -4925,7 +4925,9 @@
 			if (payload) {
 				payload->size = packet_len;
 				memcpy(payload->buf, rtpheader, packet_len);
-				ast_data_buffer_put(rtp->send_buffer, rtp->seqno, payload);
+				if (ast_data_buffer_put(rtp->send_buffer, rtp->seqno, payload)==-1) {
+					ast_free(payload);
+				}
 			}
 		}
 
@@ -7869,7 +7874,9 @@
 
 		payload->size = res;
 		memcpy(payload->buf, rtpheader, res);
-		ast_data_buffer_put(rtp->recv_buffer, seqno, payload);
+		if (ast_data_buffer_put(rtp->recv_buffer, seqno, payload)==-1) {
+			ast_free(payload);
+		}
 
 		/* If this sequence number is removed that means we had a gap and this packet has filled it in
 		 * some. Since it was part of the gap we will have already added any other missing sequence numbers
--- 1/main/data_buffer.c	2020-03-05 18:39:25.000000000 +0100
+++ 2/main/data_buffer.c	2020-04-12 09:05:37.974412788 +0200
@@ -254,7 +254,7 @@
 	AST_LIST_TRAVERSE_SAFE_END;
 
 	if (inserted == -1) {
-		return 0;
+		return -1;
 	}
 
 	if (!inserted) {
